]> git.ipfire.org Git - thirdparty/git.git/blame - git-submodule.sh
test-drop-caches: use `has_dos_drive_prefix()`
[thirdparty/git.git] / git-submodule.sh
CommitLineData
70c7ac22
LH
1#!/bin/sh
2#
4c8a9db6 3# git-submodule.sh: add, init, update or list git submodules
70c7ac22
LH
4#
5# Copyright (c) 2007 Lars Hjemli
6
1d5bec8b 7dashless=$(basename "$0" | sed -e 's/-/ /')
681b036f 8USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
64b19ffe 9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
1d5bec8b 10 or: $dashless [--quiet] init [--] [<path>...]
f6a52799 11 or: $dashless [--quiet] deinit [-f|--force] (--all| [--] <path>...)
abed000a 12 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--[no-]recommend-shallow] [--reference <repository>] [--recursive] [--] [<path>...]
adc54235 13 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
15fc56a8 14 or: $dashless [--quiet] foreach [--recursive] <command>
c32eaa8a
SB
15 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]
16 or: $dashless [--quiet] absorbgitdirs [--] [<path>...]"
8f321a39 17OPTIONS_SPEC=
091a6eb0 18SUBDIRECTORY_OK=Yes
70c7ac22 19. git-sh-setup
98fcf840 20. git-parse-remote
70c7ac22 21require_work_tree
091a6eb0
JK
22wt_prefix=$(git rev-parse --show-prefix)
23cd_to_toplevel
70c7ac22 24
f1762d77
BW
25# Tell the rest of git that any URLs we get don't come
26# directly from the user, so it can apply policy as appropriate.
27GIT_PROTOCOL_FROM_USER=0
28export GIT_PROTOCOL_FROM_USER
33cfccbb 29
5c08dbbd 30command=
ecda0723 31branch=
d27b876b 32force=
d92a3959 33reference=
70c7ac22 34cached=
48bb3033
GP
35recursive=
36init=
0060fd15 37require_init=
1c244f6e 38files=
06b1abb5 39remote=
31ca3ac3 40nofetch=
32948425 41update=
15fc56a8 42prefix=
73b0898d 43custom_name=
275cd184 44depth=
72c5f883 45progress=
70c7ac22 46
be9d0a3a
HV
47die_if_unmatched ()
48{
49 if test "$1" = "#unmatched"
50 then
c4c02bf1 51 exit ${2:-1}
be9d0a3a
HV
52 fi
53}
54
88ce00c3
TK
55#
56# Print a submodule configuration setting
57#
58# $1 = submodule name
59# $2 = option name
60# $3 = default value
61#
62# Checks in the usual git-config places first (for overrides),
63# otherwise it falls back on .gitmodules. This allows you to
64# distribute project-wide defaults in .gitmodules, while still
65# customizing individual repositories if necessary. If the option is
66# not in .gitmodules either, print a default value.
67#
68get_submodule_config () {
69 name="$1"
70 option="$2"
71 default="$3"
72 value=$(git config submodule."$name"."$option")
73 if test -z "$value"
74 then
75 value=$(git config -f .gitmodules submodule."$name"."$option")
76 fi
77 printf '%s' "${value:-$default}"
78}
79
862ae6cd
RS
80isnumber()
81{
82 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
83}
84
14111fc4
JK
85# Sanitize the local git environment for use within a submodule. We
86# can't simply use clear_local_git_env since we want to preserve some
87# of the settings from GIT_CONFIG_PARAMETERS.
88sanitize_submodule_env()
89{
89044baa 90 save_config=$GIT_CONFIG_PARAMETERS
14111fc4 91 clear_local_git_env
89044baa 92 GIT_CONFIG_PARAMETERS=$save_config
860cba61 93 export GIT_CONFIG_PARAMETERS
14111fc4
JK
94}
95
ecda0723
SV
96#
97# Add a new submodule to the working tree, .gitmodules and the index
98#
ec05df35 99# $@ = repo path
ecda0723
SV
100#
101# optional branch is stored in global branch variable
102#
23a485e3 103cmd_add()
ecda0723 104{
5c08dbbd 105 # parse $args after "submodule ... add".
091a6eb0 106 reference_path=
5c08dbbd
JH
107 while test $# -ne 0
108 do
109 case "$1" in
110 -b | --branch)
111 case "$2" in '') usage ;; esac
112 branch=$2
113 shift
114 ;;
d27b876b
JL
115 -f | --force)
116 force=$1
117 ;;
5c08dbbd 118 -q|--quiet)
2e6a30ef 119 GIT_QUIET=1
5c08dbbd 120 ;;
d92a3959
MT
121 --reference)
122 case "$2" in '') usage ;; esac
091a6eb0 123 reference_path=$2
d92a3959
MT
124 shift
125 ;;
126 --reference=*)
091a6eb0 127 reference_path="${1#--reference=}"
d92a3959 128 ;;
73b0898d
JL
129 --name)
130 case "$2" in '') usage ;; esac
131 custom_name=$2
132 shift
133 ;;
275cd184
FG
134 --depth)
135 case "$2" in '') usage ;; esac
136 depth="--depth=$2"
137 shift
138 ;;
139 --depth=*)
140 depth=$1
141 ;;
5c08dbbd
JH
142 --)
143 shift
144 break
145 ;;
146 -*)
147 usage
148 ;;
149 *)
150 break
151 ;;
152 esac
153 shift
154 done
155
091a6eb0
JK
156 if test -n "$reference_path"
157 then
158 is_absolute_path "$reference_path" ||
159 reference_path="$wt_prefix$reference_path"
160
161 reference="--reference=$reference_path"
162 fi
163
ecda0723 164 repo=$1
64394e3a 165 sm_path=$2
ecda0723 166
64394e3a 167 if test -z "$sm_path"; then
6a066230 168 sm_path=$(printf '%s\n' "$repo" |
1414e578
JL
169 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
170 fi
171
496eeeb1 172 if test -z "$repo" || test -z "$sm_path"; then
ecda0723
SV
173 usage
174 fi
175
091a6eb0
JK
176 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
177
ec05df35
ML
178 # assure repo is absolute or relative to parent
179 case "$repo" in
180 ./*|../*)
091a6eb0
JK
181 test -z "$wt_prefix" ||
182 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
183
ec05df35 184 # dereference source url relative to parent's url
63e95beb 185 realrepo=$(git submodule--helper resolve-relative-url "$repo") || exit
ec05df35
ML
186 ;;
187 *:*|/*)
188 # absolute url
189 realrepo=$repo
190 ;;
191 *)
497ee872 192 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
ec05df35
ML
193 ;;
194 esac
195
db75ada5
MG
196 # normalize path:
197 # multiple //; leading ./; /./; /../; trailing /
64394e3a 198 sm_path=$(printf '%s/\n' "$sm_path" |
db75ada5
MG
199 sed -e '
200 s|//*|/|g
201 s|^\(\./\)*||
8196e728 202 s|/\(\./\)*|/|g
db75ada5
MG
203 :start
204 s|\([^/]*\)/\.\./||
205 tstart
206 s|/*$||
207 ')
619acfc7
SB
208 if test -z "$force"
209 then
210 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
211 die "$(eval_gettext "'\$sm_path' already exists in the index")"
212 else
213 git ls-files -s "$sm_path" | sane_grep -v "^160000" > /dev/null 2>&1 &&
214 die "$(eval_gettext "'\$sm_path' already exists in the index and is not a submodule")"
215 fi
ecda0723 216
53213994
JK
217 if test -z "$force" &&
218 ! git add --dry-run --ignore-missing --no-warn-embedded-repo "$sm_path" > /dev/null 2>&1
d27b876b 219 then
6ff875c5 220 eval_gettextln "The following path is ignored by one of your .gitignore files:
64394e3a 221\$sm_path
6ff875c5 222Use -f if you really want to add it." >&2
d27b876b
JL
223 exit 1
224 fi
225
73b0898d
JL
226 if test -n "$custom_name"
227 then
228 sm_name="$custom_name"
229 else
230 sm_name="$sm_path"
231 fi
232
0383bbb9
JK
233 if ! git submodule--helper check-name "$sm_name"
234 then
235 die "$(eval_gettext "'$sm_name' is not a valid submodule name")"
236 fi
237
d4264ca3 238 # perhaps the path exists and is already a git repo, else clone it
64394e3a 239 if test -e "$sm_path"
d4264ca3 240 then
496eeeb1 241 if test -d "$sm_path"/.git || test -f "$sm_path"/.git
d4264ca3 242 then
64394e3a 243 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
d4264ca3 244 else
64394e3a 245 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
d4264ca3 246 fi
c2f93917 247
d4264ca3 248 else
4b7c286e
JL
249 if test -d ".git/modules/$sm_name"
250 then
251 if test -z "$force"
252 then
0d71dbfd 253 eval_gettextln >&2 "A git directory for '\$sm_name' is found locally with remote(s):"
4b7c286e 254 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
0d71dbfd
VA
255 die "$(eval_gettextln "\
256If you want to reuse this local git directory instead of cloning again from
257 \$realrepo
258use the '--force' option. If the local git directory is not the correct repo
259or you are unsure what this means choose another name with the '--name' option.")"
4b7c286e 260 else
0d71dbfd 261 eval_gettextln "Reactivating local git directory for submodule '\$sm_name'."
4b7c286e
JL
262 fi
263 fi
d10e3b42 264 git submodule--helper clone ${GIT_QUIET:+--quiet} --prefix "$wt_prefix" --path "$sm_path" --name "$sm_name" --url "$realrepo" ${reference:+"$reference"} ${depth:+"$depth"} || exit
d851ffb9 265 (
14111fc4 266 sanitize_submodule_env
d851ffb9
JH
267 cd "$sm_path" &&
268 # ash fails to wordsplit ${branch:+-b "$branch"...}
269 case "$branch" in
270 '') git checkout -f -q ;;
271 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
272 esac
273 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
d4264ca3 274 fi
73b0898d 275 git config submodule."$sm_name".url "$realrepo"
d4264ca3 276
53213994 277 git add --no-warn-embedded-repo $force "$sm_path" ||
64394e3a 278 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
ecda0723 279
73b0898d
JL
280 git config -f .gitmodules submodule."$sm_name".path "$sm_path" &&
281 git config -f .gitmodules submodule."$sm_name".url "$repo" &&
b9289227
TK
282 if test -n "$branch"
283 then
284 git config -f .gitmodules submodule."$sm_name".branch "$branch"
285 fi &&
31991b02 286 git add --force .gitmodules ||
64394e3a 287 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
1b614c07
BW
288
289 # NEEDSWORK: In a multi-working-tree world, this needs to be
290 # set in the per-worktree config.
291 if git config --get submodule.active >/dev/null
292 then
293 # If the submodule being adding isn't already covered by the
294 # current configured pathspec, set the submodule's active flag
295 if ! git submodule--helper is-active "$sm_path"
296 then
297 git config submodule."$sm_name".active "true"
298 fi
299 else
300 git config submodule."$sm_name".active "true"
301 fi
ecda0723
SV
302}
303
19a31f9c
ML
304#
305# Execute an arbitrary command sequence in each checked out
306# submodule
307#
308# $@ = command to execute
309#
310cmd_foreach()
311{
1d5bec8b
JH
312 # parse $args after "submodule ... foreach".
313 while test $# -ne 0
314 do
315 case "$1" in
316 -q|--quiet)
317 GIT_QUIET=1
318 ;;
15fc56a8
JH
319 --recursive)
320 recursive=1
321 ;;
1d5bec8b
JH
322 -*)
323 usage
324 ;;
325 *)
326 break
327 ;;
328 esac
329 shift
330 done
331
f030c96d
ÆAB
332 toplevel=$(pwd)
333
4dca1aa6
BC
334 # dup stdin so that it can be restored when running the external
335 # command in the subshell (and a recursive call to this function)
336 exec 3<&0
337
b0f4b408
SB
338 {
339 git submodule--helper list --prefix "$wt_prefix" ||
c4c02bf1 340 echo "#unmatched" $?
b0f4b408 341 } |
cf9e55f4 342 while read -r mode sha1 stage sm_path
19a31f9c 343 do
c4c02bf1 344 die_if_unmatched "$mode" "$sha1"
64394e3a 345 if test -e "$sm_path"/.git
19a31f9c 346 then
44431df0 347 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
ea2fa104 348 say "$(eval_gettext "Entering '\$displaypath'")"
0ea306ef 349 name=$(git submodule--helper name "$sm_path")
15fc56a8 350 (
64394e3a 351 prefix="$prefix$sm_path/"
14111fc4 352 sanitize_submodule_env
64394e3a 353 cd "$sm_path" &&
44431df0 354 sm_path=$(git submodule--helper relative-path "$sm_path" "$wt_prefix") &&
091a6eb0
JK
355 # we make $path available to scripts ...
356 path=$sm_path &&
1c4fb136
AK
357 if test $# -eq 1
358 then
359 eval "$1"
360 else
361 "$@"
362 fi &&
15fc56a8
JH
363 if test -n "$recursive"
364 then
365 cmd_foreach "--recursive" "$@"
366 fi
4dca1aa6 367 ) <&3 3<&- ||
ea2fa104 368 die "$(eval_gettext "Stopping at '\$displaypath'; script returned non-zero status.")"
19a31f9c
ML
369 fi
370 done
371}
372
70c7ac22 373#
211b7f19 374# Register submodules in .git/config
70c7ac22
LH
375#
376# $@ = requested paths (default to all)
377#
23a485e3 378cmd_init()
70c7ac22 379{
5c08dbbd
JH
380 # parse $args after "submodule ... init".
381 while test $# -ne 0
382 do
383 case "$1" in
384 -q|--quiet)
2e6a30ef 385 GIT_QUIET=1
5c08dbbd
JH
386 ;;
387 --)
388 shift
389 break
390 ;;
391 -*)
392 usage
393 ;;
394 *)
395 break
396 ;;
397 esac
398 shift
399 done
400
6e7c14e6 401 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper init ${GIT_QUIET:+--quiet} "$@"
70c7ac22
LH
402}
403
cf419828
JL
404#
405# Unregister submodules from .git/config and remove their work tree
406#
cf419828
JL
407cmd_deinit()
408{
409 # parse $args after "submodule ... deinit".
f6a52799 410 deinit_all=
cf419828
JL
411 while test $# -ne 0
412 do
413 case "$1" in
414 -f|--force)
415 force=$1
416 ;;
417 -q|--quiet)
418 GIT_QUIET=1
419 ;;
f6a52799
SB
420 --all)
421 deinit_all=t
422 ;;
cf419828
JL
423 --)
424 shift
425 break
426 ;;
427 -*)
428 usage
429 ;;
430 *)
431 break
432 ;;
433 esac
434 shift
435 done
436
f6a52799
SB
437 if test -n "$deinit_all" && test "$#" -ne 0
438 then
439 echo >&2 "$(eval_gettext "pathspec and --all are incompatible")"
440 usage
441 fi
442 if test $# = 0 && test -z "$deinit_all"
cf419828 443 then
f6a52799 444 die "$(eval_gettext "Use '--all' if you really want to deinitialize all submodules")"
cf419828
JL
445 fi
446
b0f4b408
SB
447 {
448 git submodule--helper list --prefix "$wt_prefix" "$@" ||
c4c02bf1 449 echo "#unmatched" $?
b0f4b408 450 } |
cf9e55f4 451 while read -r mode sha1 stage sm_path
cf419828 452 do
c4c02bf1 453 die_if_unmatched "$mode" "$sha1"
0ea306ef 454 name=$(git submodule--helper name "$sm_path") || exit
cf419828 455
44431df0 456 displaypath=$(git submodule--helper relative-path "$sm_path" "$wt_prefix")
091a6eb0 457
cf419828
JL
458 # Remove the submodule work tree (unless the user already did it)
459 if test -d "$sm_path"
460 then
461 # Protect submodules containing a .git directory
462 if test -d "$sm_path/.git"
463 then
0d71dbfd
VA
464 die "$(eval_gettext "\
465Submodule work tree '\$displaypath' contains a .git directory
466(use 'rm -rf' if you really want to remove it including all of its history)")"
cf419828
JL
467 fi
468
469 if test -z "$force"
470 then
7b294bf4 471 git rm -qn "$sm_path" ||
091a6eb0 472 die "$(eval_gettext "Submodule work tree '\$displaypath' contains local modifications; use '-f' to discard them")"
cf419828 473 fi
7b294bf4 474 rm -rf "$sm_path" &&
091a6eb0
JK
475 say "$(eval_gettext "Cleared directory '\$displaypath'")" ||
476 say "$(eval_gettext "Could not remove submodule work tree '\$displaypath'")"
cf419828
JL
477 fi
478
091a6eb0 479 mkdir "$sm_path" || say "$(eval_gettext "Could not create empty submodule directory '\$displaypath'")"
cf419828
JL
480
481 # Remove the .git/config entries (unless the user already did it)
482 if test -n "$(git config --get-regexp submodule."$name\.")"
483 then
484 # Remove the whole section so we have a clean state when
485 # the user later decides to init this submodule again
486 url=$(git config submodule."$name".url)
487 git config --remove-section submodule."$name" 2>/dev/null &&
091a6eb0 488 say "$(eval_gettext "Submodule '\$name' (\$url) unregistered for path '\$displaypath'")"
cf419828
JL
489 fi
490 done
491}
492
fb43e31f 493is_tip_reachable () (
01e1d544 494 sanitize_submodule_env &&
fb43e31f
SB
495 cd "$1" &&
496 rev=$(git rev-list -n 1 "$2" --not --all 2>/dev/null) &&
497 test -z "$rev"
498)
499
500fetch_in_submodule () (
01e1d544 501 sanitize_submodule_env &&
fb43e31f
SB
502 cd "$1" &&
503 case "$2" in
504 '')
505 git fetch ;;
506 *)
6cbf454a
SB
507 shift
508 git fetch $(get_default_remote) "$@" ;;
fb43e31f
SB
509 esac
510)
511
70c7ac22 512#
211b7f19 513# Update each submodule path to correct revision, using clone and checkout as needed
70c7ac22
LH
514#
515# $@ = requested paths (default to all)
516#
23a485e3 517cmd_update()
70c7ac22 518{
5c08dbbd
JH
519 # parse $args after "submodule ... update".
520 while test $# -ne 0
521 do
522 case "$1" in
523 -q|--quiet)
2e6a30ef 524 GIT_QUIET=1
5c08dbbd 525 ;;
72c5f883
JK
526 --progress)
527 progress="--progress"
528 ;;
be4d2c83 529 -i|--init)
d92a3959 530 init=1
be4d2c83 531 ;;
0060fd15
JS
532 --require-init)
533 init=1
534 require_init=1
535 ;;
06b1abb5
TK
536 --remote)
537 remote=1
538 ;;
31ca3ac3 539 -N|--no-fetch)
31ca3ac3
FF
540 nofetch=1
541 ;;
9db31bdf
NMC
542 -f|--force)
543 force=$1
544 ;;
ca2cedba 545 -r|--rebase)
32948425 546 update="rebase"
ca2cedba 547 ;;
d92a3959
MT
548 --reference)
549 case "$2" in '') usage ;; esac
550 reference="--reference=$2"
98dbe63d 551 shift
d92a3959
MT
552 ;;
553 --reference=*)
554 reference="$1"
d92a3959 555 ;;
42b49178 556 -m|--merge)
42b49178
JH
557 update="merge"
558 ;;
b13fd5c1 559 --recursive)
b13fd5c1
JH
560 recursive=1
561 ;;
efc5fb6a
JH
562 --checkout)
563 update="checkout"
564 ;;
abed000a
SB
565 --recommend-shallow)
566 recommend_shallow="--recommend-shallow"
567 ;;
568 --no-recommend-shallow)
569 recommend_shallow="--no-recommend-shallow"
570 ;;
275cd184
FG
571 --depth)
572 case "$2" in '') usage ;; esac
573 depth="--depth=$2"
574 shift
575 ;;
576 --depth=*)
577 depth=$1
578 ;;
2335b870
SB
579 -j|--jobs)
580 case "$2" in '') usage ;; esac
581 jobs="--jobs=$2"
582 shift
583 ;;
584 --jobs=*)
585 jobs=$1
586 ;;
5c08dbbd
JH
587 --)
588 shift
589 break
590 ;;
591 -*)
592 usage
593 ;;
594 *)
595 break
596 ;;
597 esac
98dbe63d 598 shift
5c08dbbd
JH
599 done
600
d92a3959
MT
601 if test -n "$init"
602 then
603 cmd_init "--" "$@" || return
604 fi
605
48308681
SB
606 {
607 git submodule--helper update-clone ${GIT_QUIET:+--quiet} \
72c5f883 608 ${progress:+"$progress"} \
48308681
SB
609 ${wt_prefix:+--prefix "$wt_prefix"} \
610 ${prefix:+--recursive-prefix "$prefix"} \
611 ${update:+--update "$update"} \
5f50f33e 612 ${reference:+"$reference"} \
48308681 613 ${depth:+--depth "$depth"} \
0060fd15 614 ${require_init:+--require-init} \
abed000a 615 ${recommend_shallow:+"$recommend_shallow"} \
2335b870 616 ${jobs:+$jobs} \
c4c02bf1 617 "$@" || echo "#unmatched" $?
48308681 618 } | {
15ffb7cd 619 err=
cf9e55f4 620 while read -r mode sha1 stage just_cloned sm_path
70c7ac22 621 do
c4c02bf1 622 die_if_unmatched "$mode" "$sha1"
48308681 623
0ea306ef 624 name=$(git submodule--helper name "$sm_path") || exit
efc5fb6a
JH
625 if ! test -z "$update"
626 then
627 update_module=$update
628 else
629 update_module=$(git config submodule."$name".update)
a2aed08b
TK
630 if test -z "$update_module"
631 then
632 update_module="checkout"
633 fi
efc5fb6a
JH
634 fi
635
44431df0 636 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
091a6eb0 637
48308681 638 if test $just_cloned -eq 1
d851ffb9 639 then
bf2d8246 640 subsha1=
e7b37caf
SB
641 case "$update_module" in
642 merge | rebase | none)
643 update_module=checkout ;;
644 esac
bf2d8246 645 else
14111fc4 646 subsha1=$(sanitize_submodule_env; cd "$sm_path" &&
5be60078 647 git rev-parse --verify HEAD) ||
091a6eb0 648 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
70c7ac22 649 fi
211b7f19 650
06b1abb5
TK
651 if test -n "$remote"
652 then
92bbe7cc 653 branch=$(git submodule--helper remote-branch "$sm_path")
06b1abb5
TK
654 if test -z "$nofetch"
655 then
656 # Fetch remote before determining tracking $sha1
6cbf454a 657 fetch_in_submodule "$sm_path" $depth ||
06b1abb5
TK
658 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
659 fi
14111fc4
JK
660 remote_name=$(sanitize_submodule_env; cd "$sm_path" && get_default_remote)
661 sha1=$(sanitize_submodule_env; cd "$sm_path" &&
06b1abb5 662 git rev-parse --verify "${remote_name}/${branch}") ||
c87302bf 663 die "$(eval_gettext "Unable to find current \${remote_name}/\${branch} revision in submodule path '\$sm_path'")"
06b1abb5
TK
664 fi
665
496eeeb1 666 if test "$subsha1" != "$sha1" || test -n "$force"
70c7ac22 667 then
9db31bdf
NMC
668 subforce=$force
669 # If we don't already have a -f flag and the submodule has never been checked out
496eeeb1 670 if test -z "$subsha1" && test -z "$force"
b9b378a0 671 then
9db31bdf 672 subforce="-f"
b9b378a0 673 fi
31ca3ac3
FF
674
675 if test -z "$nofetch"
676 then
e5f522d6
JL
677 # Run fetch only if $sha1 isn't present or it
678 # is not reachable from a ref.
fb43e31f 679 is_tip_reachable "$sm_path" "$sha1" ||
6cbf454a 680 fetch_in_submodule "$sm_path" $depth ||
091a6eb0 681 die "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
fb43e31f
SB
682
683 # Now we tried the usual fetch, but $sha1 may
684 # not be reachable from any of the refs
685 is_tip_reachable "$sm_path" "$sha1" ||
6cbf454a 686 fetch_in_submodule "$sm_path" $depth "$sha1" ||
c87302bf 687 die "$(eval_gettext "Fetched in submodule path '\$displaypath', but it did not contain \$sha1. Direct fetching of that commit failed.")"
31ca3ac3
FF
688 fi
689
877449c1 690 must_die_on_failure=
32948425 691 case "$update_module" in
a2aed08b
TK
692 checkout)
693 command="git checkout $subforce -q"
694 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
695 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
696 ;;
32948425
JH
697 rebase)
698 command="git rebase"
091a6eb0
JK
699 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
700 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
877449c1 701 must_die_on_failure=yes
32948425 702 ;;
42b49178
JH
703 merge)
704 command="git merge"
091a6eb0
JK
705 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
706 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
877449c1 707 must_die_on_failure=yes
42b49178 708 ;;
6cb5728c
CP
709 !*)
710 command="${update_module#!}"
b08238ac
SB
711 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$displaypath'")"
712 say_msg="$(eval_gettext "Submodule path '\$displaypath': '\$command \$sha1'")"
6cb5728c
CP
713 must_die_on_failure=yes
714 ;;
32948425 715 *)
a2aed08b 716 die "$(eval_gettext "Invalid update mode '$update_module' for submodule '$name'")"
32948425 717 esac
70c7ac22 718
14111fc4 719 if (sanitize_submodule_env; cd "$sm_path" && $command "$sha1")
15ffb7cd 720 then
ff968f03 721 say "$say_msg"
877449c1
JH
722 elif test -n "$must_die_on_failure"
723 then
ff968f03 724 die_with_status 2 "$die_msg"
15ffb7cd 725 else
ff968f03 726 err="${err};$die_msg"
877449c1 727 continue
15ffb7cd 728 fi
70c7ac22 729 fi
b13fd5c1
JH
730
731 if test -n "$recursive"
732 then
75bf5e60 733 (
44431df0 734 prefix=$(git submodule--helper relative-path "$prefix$sm_path/" "$wt_prefix")
3604242f 735 wt_prefix=
14111fc4 736 sanitize_submodule_env
75bf5e60 737 cd "$sm_path" &&
36141282 738 eval cmd_update
75bf5e60 739 )
15ffb7cd
FG
740 res=$?
741 if test $res -gt 0
742 then
091a6eb0 743 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
bb9d91b4 744 if test $res -ne 2
15ffb7cd 745 then
ff968f03 746 err="${err};$die_msg"
15ffb7cd
FG
747 continue
748 else
ff968f03 749 die_with_status $res "$die_msg"
15ffb7cd
FG
750 fi
751 fi
b13fd5c1 752 fi
70c7ac22 753 done
15ffb7cd
FG
754
755 if test -n "$err"
756 then
757 OIFS=$IFS
758 IFS=';'
759 for e in $err
760 do
761 if test -n "$e"
762 then
763 echo >&2 "$e"
764 fi
765 done
766 IFS=$OIFS
767 exit 1
768 fi
769 }
70c7ac22
LH
770}
771
28f9af5d
PY
772#
773# Show commit summary for submodules in index or working tree
774#
775# If '--cached' is given, show summary between index and given commit,
776# or between working tree and given commit
777#
778# $@ = [commit (default 'HEAD'),] requested paths (default all)
779#
780cmd_summary() {
f2dc06a3 781 summary_limit=-1
d0f64dd4 782 for_status=
1c244f6e 783 diff_cmd=diff-index
f2dc06a3 784
28f9af5d
PY
785 # parse $args after "submodule ... summary".
786 while test $# -ne 0
787 do
788 case "$1" in
789 --cached)
790 cached="$1"
791 ;;
1c244f6e
JL
792 --files)
793 files="$1"
794 ;;
d0f64dd4
PY
795 --for-status)
796 for_status="$1"
797 ;;
f2dc06a3 798 -n|--summary-limit)
862ae6cd
RS
799 summary_limit="$2"
800 isnumber "$summary_limit" || usage
f2dc06a3
PY
801 shift
802 ;;
862ae6cd
RS
803 --summary-limit=*)
804 summary_limit="${1#--summary-limit=}"
805 isnumber "$summary_limit" || usage
806 ;;
28f9af5d
PY
807 --)
808 shift
809 break
810 ;;
811 -*)
812 usage
813 ;;
814 *)
815 break
816 ;;
817 esac
818 shift
819 done
bffe71f4 820
f2dc06a3
PY
821 test $summary_limit = 0 && return
822
3deea89c 823 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
28f9af5d
PY
824 then
825 head=$rev
caa9c3ca 826 test $# = 0 || shift
496eeeb1 827 elif test -z "$1" || test "$1" = "HEAD"
3deea89c 828 then
14e940d7
JH
829 # before the first commit: compare with an empty tree
830 head=$(git hash-object -w -t tree --stdin </dev/null)
2ea6c2c9 831 test -z "$1" || shift
28f9af5d 832 else
3deea89c 833 head="HEAD"
28f9af5d
PY
834 fi
835
1c244f6e
JL
836 if [ -n "$files" ]
837 then
838 test -n "$cached" &&
465d6a00 839 die "$(gettext "The --cached option cannot be used with the --files option")"
1c244f6e
JL
840 diff_cmd=diff-files
841 head=
842 fi
843
28f9af5d 844 cd_to_toplevel
091a6eb0 845 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
28f9af5d 846 # Get modified modules cared by user
18076502 847 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
e1622bfc 848 sane_egrep '^:([0-7]* )?160000' |
cf9e55f4 849 while read -r mod_src mod_dst sha1_src sha1_dst status sm_path
28f9af5d
PY
850 do
851 # Always show modules deleted or type-changed (blob<->module)
496eeeb1
EP
852 if test "$status" = D || test "$status" = T
853 then
6a066230 854 printf '%s\n' "$sm_path"
496eeeb1
EP
855 continue
856 fi
927b26f8 857 # Respect the ignore setting for --for-status.
858 if test -n "$for_status"
859 then
0ea306ef 860 name=$(git submodule--helper name "$sm_path")
927b26f8 861 ignore_config=$(get_submodule_config "$name" ignore none)
496eeeb1 862 test $status != A && test $ignore_config = all && continue
927b26f8 863 fi
28f9af5d 864 # Also show added or modified modules which are checked out
974ce807 865 GIT_DIR="$sm_path/.git" git rev-parse --git-dir >/dev/null 2>&1 &&
6a066230 866 printf '%s\n' "$sm_path"
28f9af5d
PY
867 done
868 )
1cb639e6 869
d0f64dd4
PY
870 test -z "$modules" && return
871
18076502 872 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
e1622bfc 873 sane_egrep '^:([0-7]* )?160000' |
1cb639e6 874 cut -c2- |
cf9e55f4 875 while read -r mod_src mod_dst sha1_src sha1_dst status name
1cb639e6
PY
876 do
877 if test -z "$cached" &&
878 test $sha1_dst = 0000000000000000000000000000000000000000
879 then
880 case "$mod_dst" in
881 160000)
882 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
883 ;;
884 100644 | 100755 | 120000)
885 sha1_dst=$(git hash-object $name)
886 ;;
887 000000)
888 ;; # removed
889 *)
890 # unexpected type
6ff875c5 891 eval_gettextln "unexpected mode \$mod_dst" >&2
1cb639e6
PY
892 continue ;;
893 esac
894 fi
895 missing_src=
896 missing_dst=
897
898 test $mod_src = 160000 &&
974ce807 899 ! GIT_DIR="$name/.git" git rev-parse -q --verify $sha1_src^0 >/dev/null &&
1cb639e6
PY
900 missing_src=t
901
902 test $mod_dst = 160000 &&
974ce807 903 ! GIT_DIR="$name/.git" git rev-parse -q --verify $sha1_dst^0 >/dev/null &&
1cb639e6 904 missing_dst=t
bffe71f4 905
44431df0 906 display_name=$(git submodule--helper relative-path "$name" "$wt_prefix")
091a6eb0 907
1cb639e6
PY
908 total_commits=
909 case "$missing_src,$missing_dst" in
910 t,)
091a6eb0 911 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_src")"
1cb639e6
PY
912 ;;
913 ,t)
091a6eb0 914 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_dst")"
1cb639e6
PY
915 ;;
916 t,t)
091a6eb0 917 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
1cb639e6
PY
918 ;;
919 *)
920 errmsg=
921 total_commits=$(
496eeeb1 922 if test $mod_src = 160000 && test $mod_dst = 160000
1cb639e6
PY
923 then
924 range="$sha1_src...$sha1_dst"
925 elif test $mod_src = 160000
926 then
927 range=$sha1_src
928 else
929 range=$sha1_dst
930 fi
931 GIT_DIR="$name/.git" \
b0e621ad 932 git rev-list --first-parent $range -- | wc -l
1cb639e6 933 )
eed35595 934 total_commits=" ($(($total_commits + 0)))"
1cb639e6
PY
935 ;;
936 esac
937
938 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
939 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
940 if test $status = T
941 then
b3e73449
ÆAB
942 blob="$(gettext "blob")"
943 submodule="$(gettext "submodule")"
1cb639e6
PY
944 if test $mod_dst = 160000
945 then
091a6eb0 946 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
1cb639e6 947 else
091a6eb0 948 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
1cb639e6
PY
949 fi
950 else
091a6eb0 951 echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
1cb639e6
PY
952 fi
953 if test -n "$errmsg"
954 then
955 # Don't give error msg for modification whose dst is not submodule
956 # i.e. deleted or changed to blob
957 test $mod_dst = 160000 && echo "$errmsg"
958 else
496eeeb1 959 if test $mod_src = 160000 && test $mod_dst = 160000
1cb639e6 960 then
f2dc06a3
PY
961 limit=
962 test $summary_limit -gt 0 && limit="-$summary_limit"
1cb639e6 963 GIT_DIR="$name/.git" \
f2dc06a3 964 git log $limit --pretty='format: %m %s' \
1cb639e6
PY
965 --first-parent $sha1_src...$sha1_dst
966 elif test $mod_dst = 160000
967 then
968 GIT_DIR="$name/.git" \
969 git log --pretty='format: > %s' -1 $sha1_dst
970 else
971 GIT_DIR="$name/.git" \
972 git log --pretty='format: < %s' -1 $sha1_src
973 fi
974 echo
975 fi
976 echo
3ba7407b 977 done
28f9af5d 978}
70c7ac22 979#
941987a5 980# List all submodules, prefixed with:
70c7ac22
LH
981# - submodule not initialized
982# + different revision checked out
983#
984# If --cached was specified the revision in the index will be printed
985# instead of the currently checked out revision.
986#
987# $@ = requested paths (default to all)
988#
23a485e3 989cmd_status()
70c7ac22 990{
5c08dbbd
JH
991 # parse $args after "submodule ... status".
992 while test $# -ne 0
993 do
994 case "$1" in
995 -q|--quiet)
2e6a30ef 996 GIT_QUIET=1
5c08dbbd
JH
997 ;;
998 --cached)
999 cached=1
1000 ;;
64b19ffe
JH
1001 --recursive)
1002 recursive=1
1003 ;;
5c08dbbd
JH
1004 --)
1005 shift
1006 break
1007 ;;
1008 -*)
1009 usage
1010 ;;
1011 *)
1012 break
1013 ;;
1014 esac
1015 shift
1016 done
1017
a9f8a375 1018 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper status ${GIT_QUIET:+--quiet} ${cached:+--cached} ${recursive:+--recursive} "$@"
70c7ac22 1019}
2327f61e
DA
1020#
1021# Sync remote urls for submodules
1022# This makes the value for remote.$remote.url match the value
1023# specified in .gitmodules.
1024#
1025cmd_sync()
1026{
1027 while test $# -ne 0
1028 do
1029 case "$1" in
1030 -q|--quiet)
2e6a30ef 1031 GIT_QUIET=1
2327f61e
DA
1032 shift
1033 ;;
82f49f29
PH
1034 --recursive)
1035 recursive=1
1036 shift
1037 ;;
2327f61e
DA
1038 --)
1039 shift
1040 break
1041 ;;
1042 -*)
1043 usage
1044 ;;
1045 *)
1046 break
1047 ;;
1048 esac
1049 done
1050 cd_to_toplevel
b0f4b408
SB
1051 {
1052 git submodule--helper list --prefix "$wt_prefix" "$@" ||
c4c02bf1 1053 echo "#unmatched" $?
b0f4b408 1054 } |
cf9e55f4 1055 while read -r mode sha1 stage sm_path
2327f61e 1056 do
c4c02bf1 1057 die_if_unmatched "$mode" "$sha1"
e7849a96
BW
1058
1059 # skip inactive submodules
25b31f1b 1060 if ! git submodule--helper is-active "$sm_path"
e7849a96
BW
1061 then
1062 continue
1063 fi
1064
25b31f1b 1065 name=$(git submodule--helper name "$sm_path")
2327f61e 1066 url=$(git config -f .gitmodules --get submodule."$name".url)
baede9f8
JH
1067
1068 # Possibly a url relative to parent
1069 case "$url" in
1070 ./*|../*)
967b2c66
JS
1071 # rewrite foo/bar as ../.. to find path from
1072 # submodule work tree to superproject work tree
6a066230 1073 up_path="$(printf '%s\n' "$sm_path" | sed "s/[^/][^/]*/../g")" &&
967b2c66
JS
1074 # guarantee a trailing /
1075 up_path=${up_path%/}/ &&
1076 # path from submodule work tree to submodule origin repo
63e95beb 1077 sub_origin_url=$(git submodule--helper resolve-relative-url "$url" "$up_path") &&
967b2c66 1078 # path from superproject work tree to submodule origin repo
63e95beb 1079 super_config_url=$(git submodule--helper resolve-relative-url "$url") || exit
967b2c66
JS
1080 ;;
1081 *)
1082 sub_origin_url="$url"
1083 super_config_url="$url"
baede9f8
JH
1084 ;;
1085 esac
1086
e7849a96
BW
1087 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
1088 say "$(eval_gettext "Synchronizing submodule url for '\$displaypath'")"
1089 git config submodule."$name".url "$super_config_url"
1090
1091 if test -e "$sm_path"/.git
2327f61e 1092 then
e7849a96
BW
1093 (
1094 sanitize_submodule_env
1095 cd "$sm_path"
1096 remote=$(get_default_remote)
1097 git config remote."$remote".url "$sub_origin_url"
ccee6086 1098
e7849a96 1099 if test -n "$recursive"
ccee6086 1100 then
e7849a96
BW
1101 prefix="$prefix$sm_path/"
1102 eval cmd_sync
ccee6086 1103 fi
e7849a96 1104 )
2327f61e
DA
1105 fi
1106 done
1107}
70c7ac22 1108
f6f85861
SB
1109cmd_absorbgitdirs()
1110{
1111 git submodule--helper absorb-git-dirs --prefix "$wt_prefix" "$@"
1112}
1113
5c08dbbd
JH
1114# This loop parses the command line arguments to find the
1115# subcommand name to dispatch. Parsing of the subcommand specific
1116# options are primarily done by the subcommand implementations.
1117# Subcommand specific options such as --branch and --cached are
1118# parsed here as well, for backward compatibility.
1119
1120while test $# != 0 && test -z "$command"
70c7ac22
LH
1121do
1122 case "$1" in
f6f85861 1123 add | foreach | init | deinit | update | status | summary | sync | absorbgitdirs)
5c08dbbd 1124 command=$1
70c7ac22
LH
1125 ;;
1126 -q|--quiet)
2e6a30ef 1127 GIT_QUIET=1
70c7ac22 1128 ;;
ecda0723
SV
1129 -b|--branch)
1130 case "$2" in
1131 '')
1132 usage
1133 ;;
1134 esac
1135 branch="$2"; shift
1136 ;;
70c7ac22 1137 --cached)
28f9af5d 1138 cached="$1"
70c7ac22
LH
1139 ;;
1140 --)
1141 break
1142 ;;
1143 -*)
1144 usage
1145 ;;
1146 *)
1147 break
1148 ;;
1149 esac
1150 shift
1151done
1152
5c08dbbd 1153# No command word defaults to "status"
af9c9f97
RR
1154if test -z "$command"
1155then
1156 if test $# = 0
1157 then
1158 command=status
1159 else
1160 usage
1161 fi
1162fi
5c08dbbd
JH
1163
1164# "-b branch" is accepted only by "add"
1165if test -n "$branch" && test "$command" != add
1166then
ecda0723 1167 usage
5c08dbbd
JH
1168fi
1169
28f9af5d 1170# "--cached" is accepted only by "status" and "summary"
496eeeb1 1171if test -n "$cached" && test "$command" != status && test "$command" != summary
5c08dbbd 1172then
70c7ac22 1173 usage
5c08dbbd
JH
1174fi
1175
1176"cmd_$command" "$@"